BayesMIPCA<-function(X.na,M,S,L=100,verbose=T,Lstart=1000){

  res.MI<-list()

  ################
  # Initialization
  ################

  Mean<-colMeans(X.na,na.rm=TRUE)
  X<-sweep(X.na,2,Mean,FUN="-")
  X.tild<-imputePCA(X,ncp=S,method="Regularized",scale=F)$fitt
  sigma<-Estim_param(X=X,S=S)[["sigma"]]

  ###############
  # Imputation
  ###############
  for (l in 1:(Lstart+M*L)){
    #Step I
    X[is.na(X.na)]<-X.tild[is.na(X.na)]+rnorm(sum(is.na(X.na)),mean=0,sd=sigma)#imputation aleatoire
    X<-sweep(X,2,Mean,FUN="+")#decentrage

    if (l %in% c(Lstart+(1:M)*L)){
      res.MI[[(l-Lstart)/L]]<-X
      if(verbose){print(paste("tableau",(l-Lstart)/L,"Ok"))}
    }

    #Step P
    Mean<-colMeans(X)
    X<-sweep(X,2,Mean,FUN="-")
    res.pca<-PCA(X,ncp=ncol(X),scale.unit=F,graph=F)
    param<-Estim_param(X=X,S=S)
    phi<-param[["phi"]]
    sigma<-param[["sigma"]]
    Moy<-res.pca[["svd"]][["U"]]%*%diag(res.pca[["svd"]][["vs"]])%*%phi%*%t(res.pca[["svd"]][["V"]])
    Var<-diag(rep(sigma^2/min(nrow(X)-1,ncol(X))*sum(phi),ncol(X)))
    X.tild<-Moy+rmvnorm(nrow(X.na),sigma=Var)
  }
  class(res.MI)<-"BayesMIPCA"
  return(res.MI)
}





